import { AfterViewInit, EventEmitter, Injector, OnChanges, OnDestroy, OnInit, SimpleChanges } from '@angular/core';
import { Observable } from 'rxjs';
import { NgxMatSelectMediaTracker } from './ngx-mat-select-media-tracker';
export declare class NgxMatSelectDirective extends NgxMatSelectMediaTracker implements OnInit, AfterViewInit, OnDestroy, OnChanges {
    private injector;
    constructor(injector: Injector);
    private _lastSourceLen;
    private _panelMaxHeight;
    private _currentEl;
    private _clickableEl;
    private _afterClickFunc;
    matSelectEl: HTMLElement;
    clickMatSelectFunc: any;
    lazyLoad: boolean;
    source: any[];
    filteredSourceChange: EventEmitter<any[]>;
    filteredSource: any[];
    searcher: (search: string, pageNumber: number, pageSize: number) => Observable<any[]>;
    isStringArray: boolean;
    fragment: string;
    hasSearchBox: boolean;
    title: string;
    emptyLabel: string;
    searchBoxPlaceholder: string;
    maximumResultForShow: any;
    useMobileView: any;
    mobileViewType: 'FullScreen' | 'BottomSheet';
    valueMember: string;
    displayMember: string;
    value: any;
    noMoreResultLabel: string;
    useInfiniteScroll: boolean;
    inFirstLoadCallSearcher: boolean;
    inFirstLoadSearcherValue: string;
    private _isFirstLoading;
    private _pageNumber;
    private _hasMoreRow;
    searchValue: string;
    private _htmlScrollTop;
    private _htmlScrollLeft;
    private _bodyScrollTop;
    private _bodyScrollLeft;
    private _openPanelSub;
    private _closePanelSub;
    private _inputSubscription;
    private _selectionChangeSub;
    private _listBoxEl;
    private _valueChangeSub;
    private _fromSearch;
    private _searchBoxInputEl;
    private _mainLoadingElement;
    loadingContainer: string;
    loadingScrollContainer: string;
    private readonly matSelect;
    private router;
    private readonly route;
    scrollInfFunc: any;
    setloading(check: boolean): void;
    ngOnInit(): void;
    ngAfterViewInit(): void;
    private _checkIsFirstLoading;
    ngOnDestroy(): void;
    ngOnChanges(changes: SimpleChanges): void;
    onPopState(event: any): void;
    onClick(event: MouseEvent): void;
    onChangeMediaTracker: () => void;
    private _populateConfigs;
    private _bindAfterClick;
    private _handleValueChanges;
    private _valueChangeDetected;
    private _scrollProcess;
    private _scrollInfLoadingEl;
    private _noMoreResultEl;
    private _addLoadingElementForScrollInf;
    changeScrollLoadingState(show: boolean): void;
    private _addMainLoading;
    scrollInfChange(event: Event): void;
    private _addScrollInf;
    private _changeNoMoreResultState;
    private _scrollToNextItem;
    private _scrollToEndOfList;
    private _scrollInList;
    private _getListMainContainerElement;
    private _addNoMoreResultElement;
    private _removeScrollInfEvent;
    private _changeSearchBoxEnableStatus;
    private _cleanNullKeyToOption;
    private _addNullKeyToOption;
    private _moveCursorToEnd;
    private _handleBackDropAfterClose;
    private _handleOverflowAfterClose;
    private _handleSelectionAfterClose;
    private _addSearchablePanelClass;
    private timeOut;
    private _createHeaderElement;
    private _afterOpen;
    private _afterClose;
    private _changePaging;
    private _handleObserverForInputValue;
    private _preventKeyCodeList;
    private _allowedKeyCode;
    private debounceTime;
    private _checkKeyCode;
    deviceType: () => "tablet" | "mobile" | "desktop";
    private _init;
    private _syncValueAndOptions;
    private _syncSourceAndOptions;
    private _hideOptions;
    private _getPagedResult;
    refreshData(): Promise<any>;
    private _onSearch;
    private _appendNotFoundHtmlTag;
    private _handleNotFoundLabel;
    private _setMaxCount;
    private _getExp;
    private _getExpForOption;
    private _getMaxSize;
    private _changeMedia;
    private _addTitleForMobileView;
    private _removeOpacity;
    private _afterOpenForMobile;
    private _toggleParentClass;
    private _removeParentClass;
}
